Subject: RE: bug#24681: undefined reference to `mktime_internal' on solaris sparc

From: "Christian Jullien" <[email-masked]>
Date: Thu, 2 Mar 2017 06:19:58 +0100

Thank you Andy,

By stable-2.0 branch, if you mean guile-2.0.14.tar.gz, I'm afraid this issue is still there.

[jullien@pastre]~$ cd guile-2.0.14

[jullien@pastre]guile-2.0.14$ uname -a
SunOS pastre 5.10 Generic_147147-26 sun4u sparc SUNW,Ultra-5_10 Solaris

[jullien@pastre]guile-2.0.14$ gcc -v
Using built-in specs.
COLLECT_GCC=gcc
COLLECT_LTO_WRAPPER=/usr/local/libexec/gcc/sparc-sun-solaris2.10/6.2.0/lto-wrapper
Target: sparc-sun-solaris2.10
Configured with: ../configure --with-gnu-as --with-as=/usr/local/bin/as --with-gnu-ld --with-ld=/usr/local/bin/ld --enable-shared --disable-lto --disable-nls --enable-languages=c,c++
Thread model: posix
gcc version 6.2.0 (GCC)

[jullien@pastre]PKG_CONFIG_PATH=/usr/local/lib/pkgconfig ./configure; time make
...
make[2]: Entering directory '/export/home/jullien/guile-2.0.14/libguile'
make  all-am
make[3]: Entering directory '/export/home/jullien/guile-2.0.14/libguile'
  CCLD     guile
./.libs/libguile-2.0.so: undefined reference to `mktime_internal'
collect2: error: ld returned 1 exit status
make[3]: *** [Makefile:2327: guile] Error 1
make[3]: Leaving directory '/export/home/jullien/guile-2.0.14/libguile'
make[2]: *** [Makefile:2186: all] Error 2
make[2]: Leaving directory '/export/home/jullien/guile-2.0.14/libguile'
make[1]: *** [Makefile:1841: all-recursive] Error 1
make[1]: Leaving directory '/export/home/jullien/guile-2.0.14'
make: *** [Makefile:1727: all] Error 2

I'll be glad to help you and to make more tests (Btw I'm also a lisp compiler writer https://en.wikipedia.org/wiki/OpenLisp)

-----Original Message-----
From: Andy Wingo [mailto:[email-masked]] 
Sent: mercredi 1 mars 2017 13:46
To: Christian Jullien
Cc: [email-masked]
Subject: Re: bug#24681: undefined reference to `mktime_internal' on solaris sparc

Hi Christian,

On Thu 13 Oct 2016 08:03, "Christian Jullien" <[email-masked]> writes:

> Trying to compile guile on solaris sparcs (I’m using gcc 6.2) I get:
>
> CC guile-guile.o
>
> CCLD guile
>
> ./.libs/libguile-2.0.so: undefined reference to `mktime_internal'
>
> collect2: error: ld returned 1 exit status

This appears to be a Gnulib problem of some kind.  See:

  https://lists.gnu.org/archive/html/guile-devel/2016-07/msg00012.html

I believe that after updating gnulib, one of the modules we pulled in added this mktime-internal dependency.  It should be built on platforms that require it, and not otherwise.  It appears that your platform requires it but is not building it; irritating!  

I just updated Gnulib again today; I wonder if it fixes this problem.
Are you able to build from git?  If so can you try the stable-2.0 branch?

Andy